/*
 * match.c
 *
 * Este programa simplesmente testa se uma expresso regular casa (match)
 * com uma entrada (input).
 *
 * argv[1] = expresso regular
 * argv[2] = input
 *
 * ex: ./match '^12' '1234567890'
 */

/* headers necessrios */
#include <stdio.h>
#include <stdlib.h>
#include <regex.h>

/* recebe como parmetro a expresso regular e o input para
 * tentar casar */
void er_match(char *argv[])
{
	/* aloca espao para a estrutura do tipo regex_t */
	regex_t reg;

	/* compila a ER passada em argv[1]
	 * em caso de erro, a funo retorna diferente de zero */
	if (regcomp(&reg , argv[1], REG_EXTENDED|REG_NOSUB) != 0) {
		fprintf(stderr,"erro regcomp\n");
		exit(1);
	}
	/* tenta casar a ER compilada (&reg) com a entrada (argv[2]) 
	 * se a funo regexec retornar 0 casou, caso contrrio no */
	if ((regexec(&reg, argv[2], 0, (regmatch_t *)NULL, 0)) == 0)
		printf("Casou\n");
	else
		printf("No Casou\n");
}

int main(int argc, char **argv)
{
	if (argc != 3) {
		fprintf(stderr,"Uso: match <ER> <input>\n");
		return 1;
	}
	er_match(argv);
	return 0;
}
